
function DrawMainWin()

	local tempWidth = 750;
	local tempHeight = 500;

	-- Main Parent window to hold all the elements
	wMainWinParent = Turbine.UI.Lotro.Window();
	wMainWinParent:SetSize(tempWidth,tempHeight);
	wMainWinParent:SetPosition(SETTINGS.MAINWIN.X,SETTINGS.MAINWIN.Y);
	wMainWinParent:SetText(PLUGINNAME);
	wMainWinParent:SetVisible(SETTINGS.MAINWIN.VISIBLE);

	Onscreen(wMainWinParent); -- Makes sure the window is still onscreen (perhaps user changed resolution since last playing)

	wMainWinBack = Turbine.UI.Control();
	wMainWinBack:SetParent(wMainWinParent);
	wMainWinBack:SetSize(748,494);
	wMainWinBack:SetPosition(0,1);
	wMainWinBack:SetBackground(_IMAGES.MAINWINBACK);
	wMainWinBack:SetBlendMode(4);
	wMainWinBack:SetMouseVisible(false);

	-- Armoury button
	btnArmoury = Turbine.UI.Control();
	btnArmoury:SetParent(wMainWinParent);
	btnArmoury:SetPosition(tempWidth-80,3);
	btnArmoury:SetSize(30,30);
	btnArmoury:SetBlendMode(4);
	btnArmoury:SetBackground(_IMAGES.BUILDICON_NORM);

	btnArmoury.MouseEnter = function ()
		btnArmoury:SetBackground(_IMAGES.BUILDICON_OVER);
	end

	btnArmoury.MouseLeave = function ()
		btnArmoury:SetBackground(_IMAGES.BUILDICON_NORM);
	end

	btnArmoury.MouseClick = function ()
		if SETTINGS.ARMOURWIN.VISIBLE == true then
			SETTINGS.ARMOURWIN.VISIBLE = false;
		else
			SETTINGS.ARMOURWIN.VISIBLE = true;
		end

		wArmourWinParent:SetVisible(SETTINGS.ARMOURWIN.VISIBLE);
	end

	-- Character drop down
	ddCharacter = DropDown.Create(GetAltNames(),MYCHAR:GetName());
	ddCharacter:SetParent(wMainWinParent);
	ddCharacter:ApplyWidth(180);
	ddCharacter:SetPosition((tempWidth/2)-100,53);

	ddCharacter.ItemChanged = function ()
		SELECTEDCHARACTER = ddCharacter:GetText();
		RefreshQuestView(SELECTEDCHARACTER);
		RefreshTokenView(SELECTEDCHARACTER);
	end


	-- Rebuild Progress
	cProgressBarBack = Turbine.UI.Control();
	cProgressBarBack:SetParent(wMainWinParent);
	cProgressBarBack:SetSize(200,18);
	cProgressBarBack:SetPosition(tempWidth-cProgressBarBack:GetWidth()-40,54);
	cProgressBarBack:SetBackground(_IMAGES.PROGRESS_BACK);
	cProgressBarBack:SetBlendMode(4);

	cProgressBar = Turbine.UI.Control();
	cProgressBar:SetParent(cProgressBarBack);
	cProgressBar:SetSize(0,9);
	cProgressBar:SetPosition(10,5);
	cProgressBar:SetBackground(_IMAGES.PROGRESS_BAR);
	cProgressBar:SetBlendMode(4);

	lblProgress = Turbine.UI.Label();
	lblProgress:SetParent(cProgressBarBack);
	lblProgress:SetSize(200,18);
	lblProgress:SetPosition(0,0);
	lblProgress:SetForeColor(Turbine.UI.Color.Beige);
	--lblProgress:SetBackColor(Turbine.UI.Color.Red);
	lblProgress:SetFont(Verdana12);
	lblProgress:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblProgress:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblProgress:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblProgress:SetZOrder(1000);
	lblProgress:SetText("");

	lblDaysRemaining = Turbine.UI.Label();
	lblDaysRemaining:SetParent(wMainWinParent);
	lblDaysRemaining:SetSize(80,32);
	lblDaysRemaining:SetPosition(140,48);
	lblDaysRemaining:SetForeColor(Turbine.UI.Color.Beige);
	lblDaysRemaining:SetFont(TrajanPro16);
	lblDaysRemaining:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblDaysRemaining:SetText("");


	-- TOKENS --------------------------------------------------------------------------
	cWALLETTOKENS = Turbine.UI.Control();
	cWALLETTOKENS:SetParent(wMainWinParent);
	cWALLETTOKENS:SetSize(32,32);
	cWALLETTOKENS:SetPosition(40,48);
	cWALLETTOKENS:SetBlendMode(4);
	cWALLETTOKENS:SetBackground(_IMAGES.HYTBOLDTOKEN);

	cWALLETTOKENSLABEL = Turbine.UI.Label();
	cWALLETTOKENSLABEL:SetParent(cWALLETTOKENS);
	cWALLETTOKENSLABEL:SetSize(28,18);
	cWALLETTOKENSLABEL:SetPosition(cWALLETTOKENS:GetWidth()-32,15);
	cWALLETTOKENSLABEL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	cWALLETTOKENSLABEL:SetFont(TrajanPro14);
	cWALLETTOKENSLABEL:SetOutlineColor(Turbine.UI.Color.Black);
	cWALLETTOKENSLABEL:SetMouseVisible(false);
	cWALLETTOKENSLABEL:SetFontStyle(Turbine.UI.FontStyle.Outline);
	cWALLETTOKENSLABEL:SetText("0");

	cNEEDTOKENS = Turbine.UI.Control();
	cNEEDTOKENS:SetParent(wMainWinParent);
	cNEEDTOKENS:SetSize(32,32);
	cNEEDTOKENS:SetPosition(90,48);
	cNEEDTOKENS:SetBlendMode(4);
	cNEEDTOKENS:SetBackground(_IMAGES.HYTBOLDTOKEN);

	cNEEDTOKENSLABEL = Turbine.UI.Label();
	cNEEDTOKENSLABEL:SetParent(cNEEDTOKENS);
	cNEEDTOKENSLABEL:SetSize(28,18);
	cNEEDTOKENSLABEL:SetPosition(cNEEDTOKENS:GetWidth()-32,15);
	cNEEDTOKENSLABEL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	cNEEDTOKENSLABEL:SetFont(TrajanPro14);
	cNEEDTOKENSLABEL:SetOutlineColor(Turbine.UI.Color.Black);
	cNEEDTOKENSLABEL:SetMouseVisible(false);
	cNEEDTOKENSLABEL:SetFontStyle(Turbine.UI.FontStyle.Outline);
	cNEEDTOKENSLABEL:SetText("0");

	-- Control to hold the elements
    treeQuests = Turbine.UI.TreeView();
    treeQuests:SetParent(wMainWinParent);
    treeQuests:SetPosition(20,100);
    treeQuests:SetSize(tempWidth-48,(wMainWinParent:GetHeight()-treeQuests:GetTop()-30));
    --treeQuests:SetBackColor(Turbine.UI.Color.Beige);
    treeQuests:SetIndentationWidth(10);

    -- Give the tree view a scroll bar.
    sbLstQuests = Turbine.UI.Lotro.ScrollBar();
	sbLstQuests:SetParent(wMainWinParent);
	sbLstQuests:SetSize(8,treeQuests:GetHeight());
	sbLstQuests:SetPosition(treeQuests:GetLeft()+treeQuests:GetWidth()+2,treeQuests:GetTop());
	sbLstQuests:SetOrientation(Turbine.UI.Orientation.Vertical);
	sbLstQuests:SetZOrder(200000);
	sbLstQuests:SetVisible(false);

    treeQuests:SetVerticalScrollBar(sbLstQuests);


	SELECTEDCHARACTER = MYCHAR:GetName();
	RefreshQuestView(SELECTEDCHARACTER);
	RefreshTokenView(SELECTEDCHARACTER);


	cReposCursor=Turbine.UI.Window();
	cReposCursor:SetSize(32,32);
	cReposCursor:SetBackground(_IMAGES.REPOSCURSOR)
	cReposCursor:SetStretchMode(2);
	cReposCursor:SetMouseVisible(false);
	cReposCursor:SetZOrder(1000);
	cReposCursor:SetVisible(false);



	-- Window events
	wMainWinParent.Update = function (sender,args)
		wMainWinParent:SetWantsUpdates(false);
		RefreshTokenView(MYCHAR:GetName());
	end

	wMainWinParent.Closing = function()
		SETTINGS.MAINWIN.VISIBLE = false;
		Debug(_LANG.COMMAND[SETTINGS.LANGUAGE]);
	end

	wMainWinParent.PositionChanged = function()
		SETTINGS.MAINWIN.X = wMainWinParent:GetLeft();
		SETTINGS.MAINWIN.Y = wMainWinParent:GetTop();
	end

	wMainWinParent:SetWantsKeyEvents(true);

	wMainWinParent.KeyDown = function (sender,args)
		if args.Action == 268435635 then -- handles F12 button

			if SETTINGS.SHOWSCREEN == false then
				wMainWinParent:SetVisible(SETTINGS.MAINWIN.VISIBLE);
				wArmourWinParent:SetVisible(SETTINGS.ARMOURWIN.VISIBLE);
				SETTINGS.SHOWSCREEN = true;
			else
				wMainWinParent:SetVisible(false);
				wArmourWinParent:SetVisible(false);
				SETTINGS.SHOWSCREEN = false;
			end

		end

		if args.Action == 145 then -- handles Esc button
			if wMainWinParent:IsVisible() == true then
				SETTINGS.MAINWIN.VISIBLE = false;
				wMainWinParent:SetVisible(false);
				Debug(_LANG.COMMAND[SETTINGS.LANGUAGE]);
			end
			if wArmourWinParent:IsVisible() == true then
				SETTINGS.ARMOURWIN.VISIBLE = false;
				wArmourWinParent:SetVisible(false);
			end
		end

	end

end


function RefreshQuestView(CHARACTER)

	if CHARACTER == nil then return end;

	QUESTTOKENSTOTAL = 0;
	TOTALTOKENSSPENT = 0;
	NUMQUESTS = 0;
	TOTALQUESTSCOMPLETED = 0;

	rootNodes = treeQuests:GetNodes();
	rootNodes:Clear();

	deedTotalQuests = {};
	deedCompletedQuests = {};
	deedTotalTokens = {};
	deedTokenSpent = {};
	imgDeedToken = {};
	lblDeedTokens = {};

	--Get all of the quests.
	for i=1, table.maxn(_DEEDGROUPS) do

		deedTotalTokens[i] = 0;
		deedTokenSpent[i] = 0;
		deedTotalQuests[i] = 0;
		deedCompletedQuests[i] = 0;

		local CurTreeNode = Turbine.UI.TreeNode();
		CurTreeNode:SetSize(treeQuests:GetWidth(),36);

		local lblDeed = Turbine.UI.Label();
		lblDeed:SetParent(CurTreeNode);
		lblDeed:SetPosition(40,0);
		lblDeed:SetSize(300,32);
		lblDeed:SetForeColor(Turbine.UI.Color.Yellow);
		lblDeed:SetFont(TrajanPro18);
		lblDeed:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		lblDeed:SetText(_DEEDGROUPS[i][SETTINGS.LANGUAGE]);

		local cDeedProgressBarBack = Turbine.UI.Control();
		cDeedProgressBarBack:SetParent(CurTreeNode);
		cDeedProgressBarBack:SetSize(200,18);
		cDeedProgressBarBack:SetPosition(350,7);
		cDeedProgressBarBack:SetBackground(_IMAGES.PROGRESS_BACK);
		cDeedProgressBarBack:SetBlendMode(4);

		local cDeedProgressBar = Turbine.UI.Control();
		cDeedProgressBar:SetParent(cDeedProgressBarBack);
		cDeedProgressBar:SetSize(0,9);
		cDeedProgressBar:SetPosition(10,5);
		cDeedProgressBar:SetBackground(_IMAGES.PROGRESS_BAR);
		cDeedProgressBar:SetBlendMode(4);

		imgDeedToken[i] = Turbine.UI.Control();
		imgDeedToken[i]:SetParent(CurTreeNode);
		imgDeedToken[i]:SetSize(32,32);
		imgDeedToken[i]:SetPosition(0,0);
		imgDeedToken[i]:SetBlendMode(4);
		imgDeedToken[i]:SetBackground(_IMAGES.HYTBOLDTOKEN);

		lblDeedTokens[i] = Turbine.UI.Label();
		lblDeedTokens[i]:SetParent(imgDeedToken[i]);
		lblDeedTokens[i]:SetSize(28,18);
		lblDeedTokens[i]:SetPosition(imgDeedToken[i]:GetWidth()-32,15);
		lblDeedTokens[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		lblDeedTokens[i]:SetFont(TrajanPro14);
		lblDeedTokens[i]:SetForeColor(Turbine.UI.Color.Khaki);
		lblDeedTokens[i]:SetOutlineColor(Turbine.UI.Color.Black);
		lblDeedTokens[i]:SetMouseVisible(false);
		lblDeedTokens[i]:SetFontStyle(Turbine.UI.FontStyle.Outline);
		lblDeedTokens[i]:SetText("0");

		rootNodes:Add(CurTreeNode);

		local ChildNodes = CurTreeNode:GetChildNodes();

		-- Give each node its own child treeview so the user can scroll easier and still see the header.
		local curDeedHolder = Turbine.UI.TreeNode();
		curDeedHolder:SetSize(treeQuests:GetWidth()-30,0);

		local tvCurDeed = Turbine.UI.TreeView();
		tvCurDeed:SetParent(curDeedHolder);
		tvCurDeed:SetSize(curDeedHolder:GetWidth()-10,curDeedHolder:GetHeight());
		tvCurDeed:SetBackColor(Turbine.UI.Color(0,0,0));
		tvCurDeed:SetIndentationWidth(10);

		-- Give the tree view a scroll bar.
		sbLstCurDeed = Turbine.UI.Lotro.ScrollBar();
		sbLstCurDeed:SetParent(curDeedHolder);
		sbLstCurDeed:SetSize(8,tvCurDeed:GetHeight());
		sbLstCurDeed:SetPosition(tvCurDeed:GetLeft()+tvCurDeed:GetWidth()+2,tvCurDeed:GetTop());
		sbLstCurDeed:SetOrientation(Turbine.UI.Orientation.Vertical);
		sbLstCurDeed:SetZOrder(200000);
		sbLstCurDeed:SetVisible(false);

		tvCurDeed:SetVerticalScrollBar(sbLstCurDeed);

		curDeedRootNodes = tvCurDeed:GetNodes()

		-- Add child nodes.

		local _tempGroup = _QUESTSTRINGS[i];

		for j=1, table.maxn(_tempGroup) do

			local _tempQuest = _tempGroup[j];

			local TOKENS = _tempQuest.TOKENS;
			local FACTION = _FACTIONS[_tempQuest.FACTION];
			local STANDING = _STANDINGS[_tempQuest.STANDING];
			local BESTOWER = _BESTOWERS[_tempQuest.BESTOWER];
			local QUESTSTRING = _tempQuest.STRINGS[SETTINGS.LANGUAGE];
			local COMPLETED = _CHARDATA[CHARACTER]["HYTBOLD"][i][j];
			local _ARMOURINFO = _ARMOUR[_tempQuest.ARMOUR];

			local EXAMINESTRING = "<Examine:IIDDID:0x0000000000000000:" .. _ARMOURINFO.ID .. ">[" .. _ARMOURINFO.NAME[SETTINGS.LANGUAGE] .. "]<\Examine> ";

			deedTotalQuests[i] = deedTotalQuests[i] + 1;
			deedTotalTokens[i] = deedTotalTokens[i] + TOKENS;


			local CURLEFT = 3;

			if _tempQuest.TIER ~= nil then CURLEFT = 15*_tempQuest.TIER end;

			NUMQUESTS = NUMQUESTS + 1;

			if _tempQuest.PREREQ ~= nil then local _PREREQ = _tempQuest.PREREQ end;

			local CurChildNode = Turbine.UI.TreeNode();
			CurChildNode:SetSize(treeQuests:GetWidth(),50);

			local curBackground = Turbine.UI.Control();
			curBackground:SetParent(CurChildNode);
			curBackground:SetSize(658,48);
			curBackground:SetPosition(0,0);
			curBackground:SetBackground(_IMAGES.BAR);
			curBackground:SetBlendMode(4);
			curBackground:SetMouseVisible(false);

			curDeedHolder:SetHeight(curDeedHolder:GetHeight()+CurChildNode:GetHeight());

			local imgQuestToken = Turbine.UI.Control();
			imgQuestToken:SetParent(CurChildNode);
			imgQuestToken:SetSize(32,32);
			imgQuestToken:SetPosition(CURLEFT,6);
			imgQuestToken:SetBlendMode(4);
			imgQuestToken:SetBackground(_IMAGES.HYTBOLDTOKEN);

			local lblQuestTokens = Turbine.UI.Label();
			lblQuestTokens:SetParent(imgQuestToken);
			lblQuestTokens:SetSize(28,18);
			lblQuestTokens:SetPosition(imgQuestToken:GetWidth()-32,15);
			lblQuestTokens:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
			lblQuestTokens:SetFont(TrajanPro14);
			lblQuestTokens:SetForeColor(Turbine.UI.Color.Khaki);
			lblQuestTokens:SetOutlineColor(Turbine.UI.Color.Black);
			lblQuestTokens:SetMouseVisible(false);
			lblQuestTokens:SetFontStyle(Turbine.UI.FontStyle.Outline);
			lblQuestTokens:SetText(TOKENS);


			if COMPLETED == true then
				imgQuestToken:SetVisible(false);
				TOTALQUESTSCOMPLETED = TOTALQUESTSCOMPLETED + 1;
				TOTALTOKENSSPENT = TOTALTOKENSSPENT + TOKENS;
				deedCompletedQuests[i] = deedCompletedQuests[i] + 1;
				deedTokenSpent[i] = deedTokenSpent[i] + TOKENS;
			end


			CURLEFT = CURLEFT + imgQuestToken:GetWidth()+8;

			local lblQuest = Turbine.UI.Label();
			lblQuest:SetParent(CurChildNode);
			lblQuest:SetPosition(CURLEFT,3);
			lblQuest:SetSize(350,20);
			lblQuest:SetForeColor(Turbine.UI.Color.Beige);
			lblQuest:SetFont(Verdana14);
			--lblQuest:SetBackColor(Turbine.UI.Color.Red);
			lblQuest:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
			lblQuest:SetText(QUESTSTRING);

			if COMPLETED then lblQuest:SetForeColor(Turbine.UI.Color(0,1,0)) end;

			-- Armour label
			local lblArmour = Turbine.UI.Label();
			lblArmour:SetParent(CurChildNode);
			lblArmour:SetPosition(CURLEFT,23);
			lblArmour:SetSize(400,20);
			lblArmour:SetForeColor(Turbine.UI.Color.Beige);
			lblArmour:SetFont(Verdana12);
			lblArmour:SetMarkupEnabled(true);
			--lblArmour:SetBackColor(Turbine.UI.Color.Red);
			lblArmour:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
			lblArmour:SetText(EXAMINESTRING);

			CURLEFT = imgQuestToken:GetWidth() + lblQuest:GetWidth() + 50;

			local lblRep = Turbine.UI.Label();
			lblRep:SetParent(CurChildNode);
			lblRep:SetPosition(CURLEFT,3);
			lblRep:SetSize(190,20);
			lblRep:SetForeColor(Turbine.UI.Color.Beige);
			lblRep:SetFont(Verdana12);
			lblRep:SetMarkupEnabled(true);
			--lblRep:SetBackColor(Turbine.UI.Color.Red);
			lblRep:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

			if STANDING == "None" then
				lblRep:SetText(BESTOWER);
			else
				lblRep:SetText(BESTOWER .. " - " .. FACTION .. " (" .. STANDING .. ")");
			end

			CURLEFT = CURLEFT + lblRep:GetWidth()+10;

			local chkCompleted = Turbine.UI.Lotro.CheckBox();
			chkCompleted:SetParent(CurChildNode);
			chkCompleted:SetPosition(CURLEFT,5);
			chkCompleted:SetSize(40,20);
			chkCompleted:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
			chkCompleted:SetText("");
			chkCompleted:SetChecked(COMPLETED);

			chkCompleted.CheckedChanged = function (sender,args)
				_CHARDATA[CHARACTER]["HYTBOLD"][i][j] = chkCompleted:IsChecked();

				if chkCompleted:IsChecked() == true then
					imgQuestToken:SetVisible(false);
					TOTALQUESTSCOMPLETED = TOTALQUESTSCOMPLETED + 1;
					TOTALTOKENSSPENT = TOTALTOKENSSPENT + TOKENS;
					deedCompletedQuests[i] = deedCompletedQuests[i] + 1;
					lblDeed:SetText(_DEEDGROUPS[i][SETTINGS.LANGUAGE] .. "  (" .. deedCompletedQuests[i] .. "/" .. deedTotalQuests[i] .. ")");
					deedTokenSpent[i] = deedTokenSpent[i] + TOKENS;
					lblQuest:SetForeColor(Turbine.UI.Color(0,1,0));
					UpdateDeedTokens(i);
					UpdateProgress();
				else
					imgQuestToken:SetVisible(true);
					TOTALQUESTSCOMPLETED = TOTALQUESTSCOMPLETED - 1;
					TOTALTOKENSSPENT = TOTALTOKENSSPENT - TOKENS;
					deedCompletedQuests[i] = deedCompletedQuests[i] - 1;
					lblDeed:SetText(_DEEDGROUPS[i][SETTINGS.LANGUAGE] .. "  (" .. deedCompletedQuests[i] .. "/" .. deedTotalQuests[i] .. ")");
					deedTokenSpent[i] = deedTokenSpent[i] - TOKENS;
					lblQuest:SetForeColor(Turbine.UI.Color.Beige);
					UpdateDeedTokens(i);
					UpdateProgress();
				end

				UpdateToolTips(i,CHARACTER);
				SetClass(ARMOURY_SELCLASSID);

				if deedCompletedQuests[i] == deedTotalQuests[i] then
					cDeedProgressBarBack:SetVisible(false);
				else
					cDeedProgressBarBack:SetVisible(true);
					cDeedProgressBar:SetWidth(179*(deedCompletedQuests[i]/deedTotalQuests[i]));
				end

			end

			_QUESTSTRINGS[i][j]["CHECK"] = chkCompleted;
			_QUESTSTRINGS[i][j]["LABEL"] = lblQuest;

			curDeedRootNodes:Add(CurChildNode);

		end

		if curDeedHolder:GetHeight() > (treeQuests:GetHeight()-40) then curDeedHolder:SetHeight(treeQuests:GetHeight()-40) end;
		tvCurDeed:SetHeight(curDeedHolder:GetHeight());
		sbLstCurDeed:SetHeight(tvCurDeed:GetHeight());
		ChildNodes:Add(curDeedHolder);

		lblDeed:SetText(_DEEDGROUPS[i][SETTINGS.LANGUAGE] .. "  (" .. deedCompletedQuests[i] .. "/" .. deedTotalQuests[i] .. ")");

		if deedCompletedQuests[i] == deedTotalQuests[i] then
			cDeedProgressBarBack:SetVisible(false);
		else
			cDeedProgressBarBack:SetVisible(true);
			cDeedProgressBar:SetWidth(179*(deedCompletedQuests[i]/deedTotalQuests[i]));
		end

		QUESTTOKENSTOTAL = QUESTTOKENSTOTAL + deedTotalTokens[i];

		UpdateDeedTokens(i);
		UpdateToolTips(i,CHARACTER);

	end

	UpdateProgress();

end


function UpdateToolTips(DEEDID,CHARACTER)

	if DEEDID == nil or CHARACTER == nil then return end;

	-- This function updates all the tooltips within a specified deed
	local ToolTipString = _LANG.NOREQ[SETTINGS.LANGUAGE];

	for i=1, table.getn(_QUESTSTRINGS[DEEDID]) do

		local _tempQuest = _QUESTSTRINGS[DEEDID][i];

		if _tempQuest.PREREQ ~= nil then
			ToolTipString = _LANG.REQUIRES[SETTINGS.LANGUAGE] .. ":\n";
			for k,v in pairs (_tempQuest.PREREQ) do
				-- Prereq completed?
				local PRECOMPLETED = _CHARDATA[CHARACTER]["HYTBOLD"][DEEDID][v];

				if PRECOMPLETED == true then
					ToolTipString = ToolTipString .. "<rgb=#00FF00>" .. _QUESTSTRINGS[DEEDID][v]["STRINGS"][SETTINGS.LANGUAGE] .. "</rgb>\n";
				else
					ToolTipString = ToolTipString .. _QUESTSTRINGS[DEEDID][v]["STRINGS"][SETTINGS.LANGUAGE] .. "\n";
				end
			end
		end

		if _tempQuest.LABEL ~= nil then
			local tmpToolTip = Tooltip.Create(_tempQuest.LABEL,ToolTipString);
		end

	end

end


function UpdateDeedTokens(i)

	if (deedTotalTokens[i]-deedTokenSpent[i]) == 0 then
		imgDeedToken[i]:SetVisible(false);
		lblDeedTokens[i]:SetText("0");
	else
		imgDeedToken[i]:SetVisible(true);
		lblDeedTokens[i]:SetText(tostring(deedTotalTokens[i]-deedTokenSpent[i]));
	end

end


function UpdateProgress()

	if TOTALQUESTSCOMPLETED == NUMQUESTS then -- completed rebuilding.

		lblProgress:SetText(_LANG.COMPLETE[SETTINGS.LANGUAGE]);
		cProgressBar:SetWidth(179);
		cNEEDTOKENS:SetVisible(false);
		cNEEDTOKENSLABEL:SetText("0");
		lblDaysRemaining:SetText("");

	else

		local PERCENTAGE = RoundNumber((TOTALQUESTSCOMPLETED/NUMQUESTS)*100,0);
		lblProgress:SetText(TOTALQUESTSCOMPLETED .. "/" .. NUMQUESTS .. "  ( " .. tostring(PERCENTAGE) .. "% )");
		cProgressBar:SetWidth(179*(PERCENTAGE/100));
		cNEEDTOKENS:SetVisible(true);
		cNEEDTOKENSLABEL:SetText(QUESTTOKENSTOTAL - TOTALTOKENSSPENT);
		lblDaysRemaining:SetText(math.ceil((QUESTTOKENSTOTAL - TOTALTOKENSSPENT)/25) .. " " .. _LANG.DAYS[SETTINGS.LANGUAGE]);

	end

end


function RefreshTokenView(CHARACTER)

	if CHARACTER == nil then return end;


	if CHARACTER == MYCHAR:GetName() then

		-- This will check each of the tokens for the selected festival to see if they exist in the wallet.
		local TOKENINDEX = GetTokenIndex(_LANG.TOKENS.HYTBOLD[SETTINGS.LANGUAGE]);

		if TOKENINDEX > 0 then
			-- Exists in wallet.
			local TEMPITEM = MYWALLET:GetItem(TOKENINDEX);

			cWALLETTOKENSLABEL:SetText(TEMPITEM:GetQuantity());
			_CHARDATA[CHARACTER]["TOKENS"] = TEMPITEM:GetQuantity();

			MYWALLET:GetItem(TOKENINDEX).QuantityChanged = function (sender,args)
				-- Quantity changed event
				cWALLETTOKENSLABEL:SetText(TEMPITEM:GetQuantity());
				_CHARDATA[CHARACTER]["TOKENS"] = TEMPITEM:GetQuantity();
			end

		else
			_CHARDATA[CHARACTER]["TOKENS"] = 0;
			cWALLETTOKENSLABEL:SetText("0");

		end

	else

		-- Not current character so load from saved data.
		cWALLETTOKENSLABEL:SetText(_CHARDATA[CHARACTER]["TOKENS"]);

	end

end


function GetTokenIndex(TOKENNAME)

	TOKENINDEX = 0;

	for i=1, MYWALLET:GetSize() do
		if MYWALLET:GetItem(i):GetName() == TOKENNAME then
			TOKENINDEX = i;
			break;
		end
	end

	return TOKENINDEX;

end
